/****************************************************************
 ****************************************************************
 **                                                            **
 **    (C)Copyright 2005-2006, American Megatrends Inc.        **
 **                                                            **
 **            All Rights Reserved.                            **
 **                                                            **
 **        6145-F, Northbelt Parkway, Norcross,                **
 **                                                            **
 **        Georgia - 30071, USA. Phone-(770)-246-8600.         **
 **                                                            **
 ****************************************************************
 ****************************************************************/
/*****************************************************************
 *
 * AppDevice.h
 * AppDevice Commands Handler
 *
 * Author: Govind Kothandapani <govindk@ami.com>
 *       : Rama Bisa <ramab@ami.com>
 *       : Basavaraj Astekar <basavaraja@ami.com>
 *       : Bakka Ravinder Reddy <bakkar@ami.com>
 *
 *****************************************************************/
#ifndef APPDEVICE_PLUS_H
#define APPDEVICE_PLUS_H

#include "com_BmcType.h"

/*** Function Prototypes ***/
/**
 * @defgroup apcf4 IPMI2.0 Payload Commands
 * @ingroup apcf
 * IPMI2.0 RMCP+ Payload Command Handlers. Invoked by the message handler
 * @{
 **/
extern int  ActivatePayload     ( uint8_t* pReq, uint8_t ReqLen,  uint8_t* pRes);
extern int  DeactivatePayload   ( uint8_t* pReq, uint8_t ReqLen,  uint8_t* pRes);
extern int  GetPayldActStatus   ( uint8_t* pReq, uint8_t ReqLen,  uint8_t* pRes);
extern int  GetPayldInstInfo    ( uint8_t* pReq, uint8_t ReqLen,  uint8_t* pRes);
extern int  SetUsrPayloadAccess ( uint8_t* pReq, uint8_t ReqLen,  uint8_t* pRes);
extern int  GetUsrPayloadAccess ( uint8_t* pReq, uint8_t ReqLen,  uint8_t* pRes);
extern int  GetChPayloadSupport ( uint8_t* pReq, uint8_t ReqLen,  uint8_t* pRes);
extern int  GetChPayloadVersion ( uint8_t* pReq, uint8_t ReqLen,  uint8_t* pRes);
extern int  GetChOemPayloadInfo ( uint8_t* pReq, uint8_t ReqLen,  uint8_t* pRes);
extern int  GetChCipherSuites   ( uint8_t* pReq, uint8_t ReqLen,  uint8_t* pRes);
extern int  SusResPayldEncrypt  ( uint8_t* pReq, uint8_t ReqLen,  uint8_t* pRes);
extern int  SetChSecurityKeys   ( uint8_t* pReq, uint8_t ReqLen,  uint8_t* pRes);
extern int  GetSysIfcCaps       ( uint8_t* pReq, uint8_t ReqLen,  uint8_t* pRes);
/** @} */

#endif  /* APPDEVICE_H */
