#ifndef __COM_BMC_CFG_H__
#define __COM_BMC_CFG_H__

#define 	FAN_NUMBERS		4		//当前板卡有0个风扇。
#define 	MAX_FAN_NUMS 	10		//该系统最多支持10个风扇
#define 	BLADE_NUMBERS	10
#define SENSOR_NUMBERS				(15)
#define FW_VERSION_MAJOR			(1)
#define FW_VERSION_MINOR			(3)

extern uint8_t ChassisPrimaryIPMBAddr[BLADE_NUMBERS];
extern uint8_t ChassisSecondaryIPMBAddr[BLADE_NUMBERS];

//模块识别相关配置
#define DEFAULT_IDENTIFY_TIMEOUT 	(15)	//15s
#define IDENTIFY_PORT				GPIOC
#define IDENTIFY_PIN				GPIO_PIN_12
/*
0x00 0000 ~ 0x7F FFFF 	7MB		BMC Firmware
=============================================
0x70 0000 ~ 0x70 0FFF 	4KB 	IpmiConfig_0
0x70 1000 ~ 0x70 1FFF 	4KB 	IpmiConfig_1
0x70 2000 ~ 0x70 2FFF 	4KB 	IpmiConfig_2
0x70 3000 ~ 0x70 3FFF 	4KB 	IpmiConfig_3
...
0x70 F000 ~ 0x70 FFFF	4KB 	IpmiConfig_n
---------------------------------------------
0x71 0000 ~ 0x71 0FFF	4KB		User info		
0x71 1000 ~ 0x71 FFFF	60KB 	Reserve
---------------------------------------------
0x72 0000 ~ 0x72 0FFF	4KB 	FRU
0x72 1000 ~ 0x72 FFFF	60KB 	Reserve
---------------------------------------------
0x73 0000 ~ 0x73 0FFF 	4KB 	SDR
0x73 1000 ~ 0x73 1FFF	60KB 	Reserve
---------------------------------------------
0x74 0000 ~ 0x74 7FFF 	32KB 	SensorHistory
0x74 8000 ~ 0x74 8FFF 	32kB 	Reserve
---------------------------------------------
0x75 0000 ~ 0x75 FFFF 	64KB	SEL
---------------------------------------------
0x76 0000 ~ 0x7F FFFF 	640KB 	Reserve
=============================================
以上改为16MB的Flash
*/
#define CONFIG_FLASH_START 	0xF00000
#define IPMI_CFG_FLASH_ADDR 0xF00000
#define USERTBL_FLASH_ADDR 	0xF10000
#define FRU_FLASH_ADDR 		0xF20000
#define SDR_FLASH_ADDR 		0xF30000
#define SENSOR_HISTORY_FLASH_ADDR 	0xF40000
#define SEL_FLASH_ADDR 		0xF50000



#endif /* __COM_BMC_CFG_H__ */